package xyz.lychee.lagfixer.libs.adventure.text.minimessage.internal.serializer;

import java.util.Objects;
import java.util.function.BiConsumer;
import java.util.function.Function;
import java.util.function.Predicate;
import xyz.lychee.lagfixer.libs.adventure.text.format.Style;
import xyz.lychee.lagfixer.libs.annotations.NotNull;
import xyz.lychee.lagfixer.libs.annotations.Nullable;

public interface StyleClaim<V> {
   static <T> @NotNull StyleClaim<T> claim(final @NotNull String claimKey, final @NotNull Function<Style, @Nullable T> lens, final @NotNull BiConsumer<T, TokenEmitter> emitable) {
      return claim(claimKey, lens, ($) -> {
         return true;
      }, emitable);
   }

   static <T> @NotNull StyleClaim<T> claim(final @NotNull String claimKey, final @NotNull Function<Style, @Nullable T> lens, final @NotNull Predicate<T> filter, final @NotNull BiConsumer<T, TokenEmitter> emitable) {
      return new StyleClaimImpl((String)Objects.requireNonNull(claimKey, "claimKey"), (Function)Objects.requireNonNull(lens, "lens"), (Predicate)Objects.requireNonNull(filter, "filter"), (BiConsumer)Objects.requireNonNull(emitable, "emitable"));
   }

   @NotNull String claimKey();

   @Nullable Emitable apply(final @NotNull Style style);
}
